<?php
require_once "common_functions.php";
$paypal_url="www.paypal.com";
$ppal_table=fs_ppal_table();
$fsusr_table=fs_usr_table();

//set up txn log file

$paypal_txn_log="..\\log\\paypal_txn.log";
if (is_file($paypal_txn_log) == FALSE)
{
    touch ($paypal_txn_log);
    $log_msg_heading="Log Time\tRemote IP\tInvoice No\tFirstSpot Status\tPaypal Payment Status\tUser\tPlan\tQuantity\tItem Name\tPaypal txn_id\tMC Gross\tMC Fee\tTax\tPayment Gross\tPayment Fee\tPayment Type\tPayment Date\tTxn Type\tFirst Name\tLast Name\tPayer Email\tPayPal Strings\n";
    $fileHandler = fopen ($paypal_txn_log, "w");
    fwrite ($fileHandler, $log_msg_heading);
    fclose ($fileHandler);
}
$log_msg_content="";
$log_msg_ip=$_SERVER["REMOTE_ADDR"];
$log_msg_time=date("y-M-d H:i");
$log_msg_strings="";
$log_msg_strings_posted="";

$lock_file="..\\log\\lock";
$lock_count = 0;

if(is_file($lock_file) == TRUE && (time() - filemtime($lock_file)>180)) //error recovery
{
    unlink($lock_file);
}

while (is_file($lock_file) == TRUE)
{
    clearstatcache();
    sleep(1);
    $lock_count = $lock_count + 1;
    if ($lock_count > 180)
    {
        $log_msg_strings.="Fail to lock file. ";
        break;
    }
}

clearstatcache();
$lock_count = 0;

while(1)
{
    if (file_exists($lock_file) == FALSE)
    {
        if (touch ($lock_file))
        {
            $lock_file_heading="locked";
            if (($lockFileHandler = fopen ($lock_file, "w")) == TRUE)
            {
                flock ($lockFileHandler, LOCK_EX); // exclusive lock
                fwrite ($lockFileHandler, $lock_file_heading);
                break;
            }
        }
    }
    clearstatcache();
    sleep(1);

    $lock_count = $lock_count + 1;
    if ($lock_count > 180)
    {
        $log_msg_strings.="Fail to lock file. ";
        break;
    }
}


reset($HTTP_POST_VARS);
$req = 'cmd=_notify-validate';
$t_value="";
foreach ($_POST as $key => $value) {
    $t_value = stripslashes($value); //for logging purpose
    $value = urlencode(stripslashes($value));
    $req .= "&$key=$value";
    $log_msg_strings_posted .="&$key=$t_value"; //for logging purpose
}

// post back to PayPal system to validate
$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
//$fp = fsockopen ($paypal_url, 80, $errno, $errstr, 30);

$ch = curl_init();
curl_setopt ($ch, CURLOPT_URL, $paypal_url);
//curl_setopt ($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
curl_setopt ($ch, CURLOPT_HEADER, $header);
curl_setopt ($ch, CURLOPT_POST, 1); 
curl_setopt ($ch, CURLOPT_POSTFIELDS, $req); 
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt ($ch, CURLOPT_TIMEOUT, 120);
$res = curl_exec ($ch);
curl_close ($ch); 

// assign posted variables to local variables
$item_name = $_POST['item_name'];
if (isset($_POST['item_number'])) $item_number = $_POST['item_number'];
else $item_number="";
//if (isset($_POST['invoice'])) $invoice = $_POST['invoice'];
//  else $invoice = "";
$details=explode("|",$_POST['custom']);
$plan=trim($details[0]);
$invoice=$details[1];
$username=$details[2];
if (isset($_POST['payment_status'])) $payment_status =$_POST['payment_status'];
else $payment_status ="";
if (isset($_POST['mc_gross'])) $payment_amount=abs($_POST['mc_gross']);
else $payment_amount="";
if (isset($_POST['mc_currency'])) $payment_currency=$_POST['mc_currency'];
else $payment_currency="";
if (isset($_POST['txn_id'])) $txn_id=$_POST['txn_id'];
else $txn_id="";
if (isset($_POST['parent_txn_id']))
    $txn_id=$_POST['parent_txn_id'];
if (isset($_POST['receiver_email'])) $receiver_email =$_POST['receiver_email'];
else $receiver_email="";
if (isset($_POST['payer_email'])) $payer_email =$_POST['payer_email'];
else $payer_email="";
if (!isset($_POST['quantity']))
    $quantity = 1;
else $quantity = $_POST['quantity'];
// $minute = $_POST['custom'];
if (isset($_POST['last_name'])) $last_name=$_POST['last_name'];
else $last_name="";
if (isset($_POST['first_name'])) $first_name=$_POST['first_name'];
else $first_name="";
if (isset($_POST['payer_id'])) $payer_id=$_POST['payer_id'];
else $payer_id="";
if (isset($_POST['payment_type'])) $payment_type=$_POST['payment_type'];
else $payment_type="";
if (isset($_POST['payment_date'])) $payment_date=$_POST['payment_date'];
else $payment_date="";
if (isset($_POST['pending_reason'])) $pending_reason=$_POST['pending_reason'];
else $pending_reason="";
if (isset($_POST['txn_type'])) $txn_type = $_POST['txn_type'];
else $txn_type ="";
if (isset($_POST['mc_fee'])) $mc_fee = $_POST['mc_fee'];
else $mc_fee ="";
if (isset($_POST['tax'])) $tax = $_POST['tax'];
else $tax ="";
if (isset($_POST['payment_gross'])) $payment_gross = $_POST['payment_gross'];
else $payment_gross ="";
if (isset($_POST['payment_fee'])) $payment_fee = $_POST['payment_fee'];
else $payment_fee ="";
if (isset($_POST['subscr_id'])) $subscr_id = $_POST['subscr_id'];
else $subscr_id ="";
if (isset($_POST['subscr_date'])) $subscr_date = $_POST['subscr_date'];
else $subscr_date ="";

$settingobj = new COM("FSCONFIG.Cfgmgr") or die("ppal_ipn.php FSCONFIG.Cfgmgr Object cannot be created!");                        
$invoice_start=$settingobj->getKey( "ppal_invoice_start", "paypal");
$plan_table=$settingobj->getKey( "Datasource_Plans_Tablename", "gateway");
// release the COM object
$settingobj->Release();
$settingobj=null;

// $log_msg_prefix="Invoice No:\t".$invoice."\tPaypal txn_id:\t".$txn_id."\tStatus:\t".$payment_status."\t";

$sql_paypal=", PAYER_ID='$payer_id', PAYEREMAIL='$payer_email', LAST_NAME='$last_name', FIRST_NAME='$first_name', PAY_TYPE='$payment_type', TXN_ID='$txn_id', PAY_DATE='$payment_date', PENDREASON='$pending_reason' ";


if (strcmp ($res, "VERIFIED") == 0)
{
    //check receiver_email = ppal_business
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("ppal_ipn.php FSCONFIG.Cfgmgr Object cannot be created!");
    $business=$settingobj->getKey( "ppal_business", "paypal");
    $pending_release=$settingobj->getKey( "ppal_pending_release", "paypal");
    // release the COM object
    $settingobj->Release();
    $settingobj=null;

    if ($txn_type=="reversal") 
    {
        $log_msg_strings.="A reversal has been taken place.";
        //$mc_gross=-1 * $mc_gross;
    }

    else if ($txn_type=="subscr_signup")
    {
        if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
        {
            //check invoice, item_name, custom = plan
            $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username';";
            $result=db_query($q);
            $count = 0;
            $count2 = 0;
            while(odbc_fetch_row($result))
            {
                $count = 1; 
                //check subscr_id has not been processed                
                $q2="SELECT * FROM ".$ppal_table." where SUBSCR_ID='$subscr_id';";
                $result2=db_query($q2);

                while(odbc_fetch_row($result2))
                {
                    $count2 = $count2 + 1;              
                }

                if ($count2 <= 1)
                {
                    $q2="SELECT * FROM ".$ppal_table." where INVOICE = $invoice AND USERNAME= '$username';";
                    $result2=db_query($q2);

                    if (strcmp (odbc_result($result2, "PAY_STATUS"), "Sign Up Request Accepted") == 0)
                    {
                        $log_msg_strings.= "This transaction has been processed and completed previously. No extra credit will be issued.";
                        echo "Previously processed";    
                    }
                    else
                    {
                        $q="Update ".$ppal_table." set PAY_STATUS = 'Sign Up Request Accepted'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $q="Update ".$ppal_table." set TXN_TYPE = '$txn_type'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $q="Update ".$ppal_table." set SUBSCR_ID = '$subscr_id'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $q="Update ".$ppal_table." set SUBSCRDATE = '$subscr_date'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $log_msg_strings.= "Status changed to subscr_signup. No extra credit will be issued.";
                        echo "subscr_signup";
                    }
                }
                else
                {
                    $log_msg_strings.="More than one records of the same subscr_id. No credit issued.";
                    echo "More than 1 record";
                }
            }
            if ($count != 1)
            {
                $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
                echo "error: no record for this invoice, item_name, custom = plan" ;
            }
        }
        else
        {
            $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
            echo "error: receiver_email != ppal_business";
        }
    }
    else if ($txn_type=="subscr_cancel")
    {
        if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
        {
            //check invoice, item_name, custom = plan
            $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username';";
            $result=db_query($q);
            $count = 0;
            $count2 = 0;    
            while(odbc_fetch_row($result))
            {
                $count = $count + 1;
                //check subscr_id has not been processed
                $q2="SELECT * FROM ".$ppal_table." where SUBSCR_ID='$subscr_id';";
                $result2=db_query($q2);
                while(odbc_fetch_row($result2))
                {
                    $count2 = $count2 + 1;
                }

                if ($count2 < 1)
                {
                    $q2="SELECT * FROM ".$ppal_table." where INVOICE = $invoice AND USERNAME= '$username';";
                    $result2=db_query($q2);

                    if (strcmp (odbc_result($result2, "PAY_STATUS"), "Completed") == 0)
                    {
                        $log_msg_strings.= "This transaction has been processed and completed previously. No extra credit will be issued.";
                        echo "Previously processed";    
                    }
                    else
                    {
                        $q="Update ".$ppal_table." set PAY_STATUS = 'Cancelled'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $q="Update ".$ppal_table." set TXN_TYPE = '$txn_type'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $q="Update ".$ppal_table." set SUBSCR_ID = '$subscr_id'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $q="Update ".$ppal_table." set SUBSCRDATE = '$subscr_date'".$sql_paypal." where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $log_msg_strings.= "Status changed to subscr_cancel. No extra credit will be issued.";
                        echo "subscr_cancel";                   
                    }
                }
                else
                {
                    $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                    $result3=db_query($q3);
                    $max_no=1;
                    while(odbc_fetch_row($result3))
                    {
                        $max_no=round(odbc_result($result3,1));
                    }
                    if ($max_no >= $invoice_start) $max=round($max_no)+1;
                    else $max=$invoice_start;

                    $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Cancelled', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                    $result_insert=db_query($q_insert);
                    $log_msg_strings.="Status added to subscr_cancel. No extra credit will be issued.";
                    echo "subscr_cancel";
                }

            }
            if ($count != 1)
            {
                $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
                echo "error: no record for this invoice, item_name, custom = plan" ;
            }
        }
        else
        {
            $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
            echo "error: receiver_email != ppal_business";
        }
    }
    else if ($txn_type=="subscr_failed")
    {
        if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
        {
            //check invoice, item_name, custom = plan
            $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username';";
            $result=db_query($q);
            $count = 0;
            $count2 = 0;    
            while(odbc_fetch_row($result))
            {
                $count = $count + 1;
                //check subscr_id has been processed
                $q2="SELECT * FROM ".$ppal_table." where SUBSCR_ID='$subscr_id';";
                $result2=db_query($q2);
                while(odbc_fetch_row($result2))
                {
                    $count2 = $count2 + 1;
                }

                if ($count2 >= 1)
                {
                    $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                    $result3=db_query($q3);
                    $max_no=1;
                    while(odbc_fetch_row($result3))
                    {
                        $max_no=round(odbc_result($result3,1));
                    }
                    if ($max_no >= $invoice_start) $max=round($max_no)+1;
                    else $max=$invoice_start;

                    $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Payment Failed', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                    $result_insert=db_query($q_insert);

                    $log_msg_strings.="Payment Failed. No extra credit will be issued.";
                    echo "subscr_failed";
                }
                else
                {
                    $log_msg_strings.="Subscription have not been sign up.";
                    echo "Subscription have not been sign up.";
                }
            }
            if ($count != 1)
            {
                $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
                echo "error: no record for this invoice, item_name, custom = plan" ;
            }
        }
        else
        {
            $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
            echo "error: receiver_email != ppal_business";
        }
    }
    else if ($txn_type=="subscr_payment")
    {
        if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
        {
            //check invoice, item_name, custom = plan
            $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username';";
            $result=db_query($q);
            $count = 0;
            $count2 = 0;    
            while(odbc_fetch_row($result))
            {
                $count = $count + 1;
                //check mc_gross >= amount x quantity
                if ($payment_amount >= odbc_result($result, "AMOUNT") * odbc_result($result, "QUANTITY"))
                {
                    $q2="SELECT * FROM ".$ppal_table." where SUBSCR_ID = '$subscr_id' AND USERNAME= '$username';";
                    $result2=db_query($q2);
                    $payment_found = false;
                    $U_NAME=$username;
                    while(odbc_fetch_row($result2))
                    {
                        $U_NAME = odbc_result($result2, "USERNAME");

                        if (strcmp (odbc_result($result2, "TXN_TYPE"), "subscr_payment") == 0)
                        {
                            $payment_found = true;
                            $new_invoice = odbc_result($result2, "INVOICE");
                            if (strcmp ($payment_status, "Completed") == 0)
                            {
                                if (strcmp (odbc_result($result2, "PAY_STATUS"), "PendingY") == 0)
                                {
                                    $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $new_invoice and username = '$username';";
                                    $result_update=db_query($q);
                                    $log_msg_strings.= "Status changed from PendingY to Completed. No extra credit will be issued.";
                                    echo "Pending Released = Y updated to completed";
                                    break;
                                }
                                else if (strcmp (odbc_result($result2, "PAY_STATUS"), "PendingN") == 0)
                                {
                                    $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $new_invoice and username = '$username';";
                                    $result_update=db_query($q);

                                    $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                    $result_plan = db_query($q_plan);

                                    $count_plan = 0;
                                    while(odbc_fetch_row($result_plan))
                                    {
                                        $count_plan = $count_plan + 1;
                                    }

                                    if ($count_plan == 0)
                                    {
                                        $log_msg_strings.="Availiable plan does not exists.";
                                        echo "Availiable plan does not exists";
                                    }
                                    else
                                    {
                                        $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                        $btul = odbc_result($result_plan, 'BTUL');
                                        $btdl = odbc_result($result_plan, 'BTDL');
                                        $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                        $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                        $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                        $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                        $sdate = odbc_result($result_plan, 'SDATE');
                                        $edate = odbc_result($result_plan, 'EDATE');
                                        $logins = odbc_result($result_plan, 'LOGINS');
                                        $minutes = odbc_result($result_plan, 'EMINUTES');
                                        $startmod = odbc_result($result_plan, 'STARTMOD');
                                        $plan_status = odbc_result($result_plan, 'STATUS');
                                        $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                        $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                        $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                        $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                        $result_usr = db_query($q_usr);

                                        $q = "UPDATE ".$fsusr_table." SET ";

                                        if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                            $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                        else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                            $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                        else
                                            $q .= "TIMELEFT = NULL, ";
                                        if ($btul != "")
                                            $q .= "BTUL = ($btul * $quantity), ";
                                        else
                                            $q .= "BTUL = NULL, ";
                                        if ($btdl != "")
                                            $q .= "BTDL = ($btdl * $quantity), ";
                                        else
                                            $q .= "BTDL = NULL, ";
                                        if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                            $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                        else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                            $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                        else
                                            $q .= "BWQUOTA = NULL, ";
                                        if ($bwcount != "")
                                            $q .= "BWCOUNT = $bwcount, ";
                                        else
                                            $q .= "BWCOUNT = NULL, ";
                                        if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                            $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                        else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                            $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                        else
                                            $q .= "BWQUOTAUL = NULL, ";
                                        if ($bwcountul != "")
                                            $q .= "BWCOUNTUL = $bwcountul, ";
                                        else
                                            $q .= "BWCOUNTUL = NULL, ";
                                        if ($sdate != "")
                                            $q .= "SDATE = '$sdate', ";
                                        else
                                            $q .= "SDATE = NULL, ";
                                        if ($edate != "")
                                            $q .= "EDATE = '$edate', ";
                                        else
                                            $q .= "EDATE = NULL, ";
                                        if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                            $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                        else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                            $q .= "LOGINS = ($logins * $quantity), ";
                                        if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                            $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                        else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                            $q .= "EMINUTES = ($minutes * $quantity), ";
                                        if ($startmod != "")
                                            $q .= "STARTMOD = $startmod, ";
                                        if ($plan_status != "")
                                            $q .= "STATUS = $plan_status, ";
                                        if ($bwrmethod != "")
                                            $q .= "BWRMETHOD = '$bwrmethod', ";
                                        if ($bwrperiod != "")
                                            $q .= "BWRPERIOD = $bwrperiod, ";
                                        else
                                            $q .= "BWRPERIOD = NULL, ";
                                        if ($bwrdate != "")
                                            $q .= "BWRDATE = $bwrdate ";
                                        else
                                            $q .= "BWRDATE = NULL ";

                                        $q .= "WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);

                                        if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                        {
                                            $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                            $result_update=db_query($q);
                                        }

                                        $log_msg_strings.="Status changed from PendingN to Completed. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                        echo "Pending Released = N updated to completed, plan updated";                                         
                                        break;
                                    }
                                }
                                else if (strcmp (odbc_result($result2, "PAY_STATUS"), "") == 0)
                                {
                                    $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $new_invoice and username = '$username';";
                                    $result_update=db_query($q);
                                    $q="Update ".$ppal_table." set SUBSCR_ID = '$subscr_id'".$sql_paypal." where invoice = $invoice and username = '$username';";
                                    $result_update=db_query($q);

                                    $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                    $result_plan = db_query($q_plan);

                                    $count_plan = 0;
                                    while(odbc_fetch_row($result_plan))
                                    {
                                        $count_plan = $count_plan + 1;
                                    }

                                    if ($count_plan == 0)
                                    {
                                        $log_msg_strings.="Availiable plan does not exists.";
                                        echo "Availiable plan does not exists";
                                    }
                                    else
                                    {
                                        $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                        $btul = odbc_result($result_plan, 'BTUL');
                                        $btdl = odbc_result($result_plan, 'BTDL');
                                        $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                        $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                        $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                        $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                        $sdate = odbc_result($result_plan, 'SDATE');
                                        $edate = odbc_result($result_plan, 'EDATE');
                                        $logins = odbc_result($result_plan, 'LOGINS');
                                        $minutes = odbc_result($result_plan, 'EMINUTES');
                                        $startmod = odbc_result($result_plan, 'STARTMOD');
                                        $plan_status = odbc_result($result_plan, 'STATUS');
                                        $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                        $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                        $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                        $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                        $result_usr = db_query($q_usr);

                                        $q = "UPDATE ".$fsusr_table." SET ";

                                        if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                            $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                        else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                            $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                        else
                                            $q .= "TIMELEFT = NULL, ";
                                        if ($btul != "")
                                            $q .= "BTUL = ($btul * $quantity), ";
                                        else
                                            $q .= "BTUL = NULL, ";
                                        if ($btdl != "")
                                            $q .= "BTDL = ($btdl * $quantity), ";
                                        else
                                            $q .= "BTDL = NULL, ";
                                        if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                            $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                        else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                            $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                        else
                                            $q .= "BWQUOTA = NULL, ";
                                        if ($bwcount != "")
                                            $q .= "BWCOUNT = $bwcount, ";
                                        else
                                            $q .= "BWCOUNT = NULL, ";
                                        if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                            $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                        else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                            $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                        else
                                            $q .= "BWQUOTAUL = NULL, ";
                                        if ($bwcountul != "")
                                            $q .= "BWCOUNTUL = $bwcountul, ";
                                        else
                                            $q .= "BWCOUNTUL = NULL, ";
                                        if ($sdate != "")
                                            $q .= "SDATE = '$sdate', ";
                                        else    
                                            $q .= "SDATE = NULL, ";
                                        if ($edate != "")
                                            $q .= "EDATE = '$edate', ";
                                        else
                                            $q .= "EDATE = NULL, ";
                                        if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                            $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                        else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                            $q .= "LOGINS = ($logins * $quantity), ";
                                        if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                            $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                        else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                            $q .= "EMINUTES = ($minutes * $quantity), ";
                                        if ($startmod != "")
                                            $q .= "STARTMOD = $startmod, ";
                                        if ($plan_status != "")
                                            $q .= "STATUS = $plan_status, ";
                                        if ($bwrmethod != "")
                                            $q .= "BWRMETHOD = '$bwrmethod', ";
                                        if ($bwrperiod != "")
                                            $q .= "BWRPERIOD = $bwrperiod, ";
                                        else
                                            $q .= "BWRPERIOD = NULL, ";
                                        if ($bwrdate != "")
                                            $q .= "BWRDATE = $bwrdate ";
                                        else
                                            $q .= "BWRDATE = NULL ";

                                        $q .= "WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);

                                        if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                        {
                                            $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                            $result_update=db_query($q);
                                        }

                                        $log_msg_strings.="Status changed to Completed. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                        echo "Updated";                 
                                        break;
                                    }
                                }
                                else if (strcmp(odbc_result($result2, "PAY_STATUS"), "Completed") == 0)
                                {
                                    $payment_found = false;
                                }
                                else
                                {
                                    $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                                    $result3=db_query($q3);
                                    $max_no=1;
                                    while(odbc_fetch_row($result3))
                                    {
                                        $max_no=round(odbc_result($result3,1));
                                    }
                                    if ($max_no >= $invoice_start) $max=round($max_no)+1;
                                    else $max=$invoice_start;

                                    $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Completed', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                                    $result_insert=db_query($q_insert);

                                    $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                    $result_plan = db_query($q_plan);

                                    $count_plan = 0;
                                    while(odbc_fetch_row($result_plan))
                                    {
                                        $count_plan = $count_plan + 1;
                                    }

                                    if ($count_plan == 0)
                                    {
                                        $log_msg_strings.="Availiable plan does not exists.";
                                        echo "Availiable plan does not exists";
                                    }
                                    else
                                    {
                                        $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                        $btul = odbc_result($result_plan, 'BTUL');
                                        $btdl = odbc_result($result_plan, 'BTDL');
                                        $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                        $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                        $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                        $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                        $sdate = odbc_result($result_plan, 'SDATE');
                                        $edate = odbc_result($result_plan, 'EDATE');
                                        $logins = odbc_result($result_plan, 'LOGINS');
                                        $minutes = odbc_result($result_plan, 'EMINUTES');
                                        $startmod = odbc_result($result_plan, 'STARTMOD');
                                        $plan_status = odbc_result($result_plan, 'STATUS');
                                        $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                        $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                        $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                        $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                        $result_usr = db_query($q_usr);

                                        $q = "UPDATE ".$fsusr_table." SET ";

                                        if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                            $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                        else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                            $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                        else
                                            $q .= "TIMELEFT = NULL, ";
                                        if ($btul != "")
                                            $q .= "BTUL = ($btul * $quantity), ";
                                        else
                                            $q .= "BTUL = NULL, ";
                                        if ($btdl != "")
                                            $q .= "BTDL = ($btdl * $quantity), ";
                                        else
                                            $q .= "BTDL = NULL, ";
                                        if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                            $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                        else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                            $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                        else
                                            $q .= "BWQUOTA = NULL, ";
                                        if ($bwcount != "")
                                            $q .= "BWCOUNT = $bwcount, ";
                                        else
                                            $q .= "BWCOUNT = NULL, ";
                                        if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                            $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                        else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                            $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                        else
                                            $q .= "BWQUOTAUL = NULL, ";
                                        if ($bwcountul != "")
                                            $q .= "BWCOUNTUL = $bwcountul, ";
                                        else
                                            $q .= "BWCOUNTUL = NULL, ";
                                        if ($sdate != "")
                                            $q .= "SDATE = '$sdate', ";
                                        else
                                            $q .= "SDATE = NULL, ";
                                        if ($edate != "")
                                            $q .= "EDATE = '$edate', ";
                                        else
                                            $q .= "EDATE = NULL, ";
                                        if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                            $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                        else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                            $q .= "LOGINS = ($logins * $quantity), ";
                                        if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                            $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                        else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                            $q .= "EMINUTES = ($minutes * $quantity), ";
                                        if ($startmod != "")
                                            $q .= "STARTMOD = $startmod, ";
                                        if ($plan_status != "")
                                            $q .= "STATUS = $plan_status, ";
                                        if ($bwrmethod != "")
                                            $q .= "BWRMETHOD = '$bwrmethod', ";
                                        if ($bwrperiod != "")
                                            $q .= "BWRPERIOD = $bwrperiod, ";
                                        else
                                            $q .= "BWRPERIOD = NULL, ";
                                        if ($bwrdate != "")
                                            $q .= "BWRDATE = $bwrdate ";
                                        else
                                            $q .= "BWRDATE = NULL ";

                                        $q .= "WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);

                                        if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                        {
                                            $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                            $result_update=db_query($q);
                                        }

                                        $log_msg_strings.="Status changed to Completed. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                        echo "Updated";                 
                                        break;
                                    }
                                }
                            }

                            if (strcmp ($payment_status, "Pending") == 0)
                            {
                                if (strcmp (odbc_result($result2, "PAY_STATUS"), "Completed") == 0)
                                {
                                    $not_update = true;
                                    continue;
                                }
                                else if (strcmp (odbc_result($result2, "PAY_STATUS"), "Cancelled") == 0)
                                {
                                    continue;
                                }
                                else if (strcmp (odbc_result($result2, "PAY_STATUS"), "Payment Failed") == 0)
                                {
                                    continue;
                                }
                                else if (strcmp (odbc_result($result2, "PAY_STATUS"), "Sign Up Request Accepted") == 0)
                                {
                                    continue;
                                }
                                else if (strcmp (odbc_result($result2, "PAY_STATUS"), "End Of Term") == 0)
                                {
                                    continue;
                                }
                                else
                                {
                                    $not_update = false;
                                    if (strcmp ($pending_release, "yes") == 0)
                                    {
                                        $q="SELECT * from ".$ppal_table." where invoice =$new_invoice and pay_status = 'PendingY' and USERNAME = '$username' and SUBSCR_ID = '$subscr_id';";
                                        $result_update=db_query($q);
                                        if (odbc_fetch_row($result_update) == FALSE)
                                        {
                                            $payment_status = "PendingY";
                                            $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $new_invoice and username='$username';";
                                            $result_update=db_query($q);

                                            $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                            $result_plan = db_query($q_plan);

                                            $count_plan = 0;
                                            while(odbc_fetch_row($result_plan))
                                            {
                                                $count_plan = $count_plan + 1;
                                            }

                                            if ($count_plan == 0)
                                            {
                                                $log_msg_strings.="Availiable plan does not exists.";
                                                echo "Availiable plan does not exists";
                                            }
                                            else
                                            {
                                                $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                                $btul = odbc_result($result_plan, 'BTUL');
                                                $btdl = odbc_result($result_plan, 'BTDL');
                                                $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                                $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                                $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                                $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                                $sdate = odbc_result($result_plan, 'SDATE');
                                                $edate = odbc_result($result_plan, 'EDATE');
                                                $logins = odbc_result($result_plan, 'LOGINS');
                                                $minutes = odbc_result($result_plan, 'EMINUTES');
                                                $startmod = odbc_result($result_plan, 'STARTMOD');
                                                $plan_status = odbc_result($result_plan, 'STATUS');
                                                $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                                $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                                $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                                $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                                $result_usr = db_query($q_usr);

                                                $q = "UPDATE ".$fsusr_table." SET ";

                                                if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                                    $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                                else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                                    $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                                else
                                                    $q .= "TIMELEFT = NULL, ";
                                                if ($btul != "")
                                                    $q .= "BTUL = ($btul * $quantity), ";
                                                else
                                                    $q .= "BTUL = NULL, ";
                                                if ($btdl != "")
                                                    $q .= "BTDL = ($btdl * $quantity), ";
                                                else
                                                    $q .= "BTDL = NULL, ";
                                                if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                                    $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                                else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                                    $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                                else
                                                    $q .= "BWQUOTA = NULL, ";
                                                if ($bwcount != "")
                                                    $q .= "BWCOUNT = $bwcount, ";
                                                else
                                                    $q .= "BWCOUNT = NULL, ";
                                                if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                                    $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                                else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                                    $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                                else
                                                    $q .= "BWQUOTAUL = NULL, ";
                                                if ($bwcountul != "")
                                                    $q .= "BWCOUNTUL = $bwcountul, ";
                                                else
                                                    $q .= "BWCOUNTUL = NULL, ";
                                                if ($sdate != "")
                                                    $q .= "SDATE = '$sdate', ";
                                                else
                                                    $q .= "SDATE = NULL, ";
                                                if ($edate != "")
                                                    $q .= "EDATE = '$edate', ";
                                                else
                                                    $q .= "EDATE = NULL, ";
                                                if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                                    $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                                else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                                    $q .= "LOGINS = ($logins * $quantity), ";
                                                if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                                    $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                                else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                                    $q .= "EMINUTES = ($minutes * $quantity), ";
                                                if ($startmod != "")
                                                    $q .= "STARTMOD = $startmod, ";
                                                if ($plan_status != "")
                                                    $q .= "STATUS = $plan_status, ";
                                                if ($bwrmethod != "")
                                                    $q .= "BWRMETHOD = '$bwrmethod', ";
                                                if ($bwrperiod != "")
                                                    $q .= "BWRPERIOD = $bwrperiod, ";
                                                else
                                                    $q .= "BWRPERIOD = NULL, ";
                                                if ($bwrdate != "")
                                                    $q .= "BWRDATE = $bwrdate ";
                                                else
                                                    $q .= "BWRDATE = NULL ";

                                                $q .= "WHERE NAME = '$U_NAME';";
                                                $result_update=db_query($q);

                                                if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                                {
                                                    $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                                    $result_update=db_query($q);
                                                }

                                                $log_msg_strings.="Status changed to PendingY. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                                echo "Pending with release updated";
                                            }
                                        }
                                        else
                                        {
                                            $log_msg_strings.= "Duplicated PendingY requests. No extra credit issued.";
                                            echo "PendingY updated before already.";
                                        }
                                        break;
                                    }

                                    if (strcmp ($pending_release, "no") == 0)
                                    {
                                        $q="SELECT * from ".$ppal_table." where invoice =$new_invoice and pay_status = 'PendingY' and USERNAME = '$username';";
                                        $result_update=db_query($q);
                                        if (odbc_fetch_row($result_update) == FALSE)
                                        {
                                            $payment_status = "PendingN";
                                            $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $new_invoice and username='$username';";
                                            $result_update=db_query($q);    
                                            $log_msg_strings.="Status changed to PendingN. No credit issued yet.";
                                            echo "Pending with NOT release updated";
                                        }
                                        else
                                        {
                                            $log_msg_strings.="Ignore request to change status from PendingY to PendingN. No credit issued.";
                                            echo "PendingY updated before already.";
                                        }
                                        break;
                                    }
                                }
                            }

                            if (strcmp ($payment_status, "Refunded") == 0)
                            {
                                $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                                $result3=db_query($q3);
                                $max_no=1;
                                while(odbc_fetch_row($result3))
                                {
                                    $max_no=round(odbc_result($result3,1));
                                }
                                if ($max_no >= $invoice_start) $max=round($max_no)+1;
                                else $max=$invoice_start;

                                $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Refunded', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                                $result_insert=db_query($q_insert);

                                $log_msg_strings.="A refund has been confirmed. Status changed to Refunded. No credit deducted.";

                                break;
                            }
                        }
                    }
                    if ($payment_found == false)
                    {

                        if (strcmp ($payment_status, "Completed") == 0)
                        {
                            $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                            $result3=db_query($q3);
                            $max_no=1;
                            while(odbc_fetch_row($result3))
                            {
                                $max_no=round(odbc_result($result3,1));
                            }
                            if ($max_no >= $invoice_start) $max=round($max_no)+1;
                            else $max=$invoice_start;

                            $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Completed', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                            $result_insert=db_query($q_insert);

                            $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                            $result_plan = db_query($q_plan);

                            $count_plan = 0;
                            while(odbc_fetch_row($result_plan))
                            {
                                $count_plan = $count_plan + 1;
                            }

                            if ($count_plan == 0)
                            {
                                $log_msg_strings.="Availiable plan does not exists.";
                                echo "Availiable plan does not exists";
                            }
                            else
                            {
                                $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                $btul = odbc_result($result_plan, 'BTUL');
                                $btdl = odbc_result($result_plan, 'BTDL');
                                $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                $sdate = odbc_result($result_plan, 'SDATE');
                                $edate = odbc_result($result_plan, 'EDATE');
                                $logins = odbc_result($result_plan, 'LOGINS');
                                $minutes = odbc_result($result_plan, 'EMINUTES');
                                $startmod = odbc_result($result_plan, 'STARTMOD');
                                $plan_status = odbc_result($result_plan, 'STATUS');
                                $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                $result_usr = db_query($q_usr);

                                $q = "UPDATE ".$fsusr_table." SET ";

                                if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                    $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                    $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                else
                                    $q .= "TIMELEFT = NULL, ";
                                if ($btul != "")
                                    $q .= "BTUL = ($btul * $quantity), ";
                                else
                                    $q .= "BTUL = NULL, ";
                                if ($btdl != "")
                                    $q .= "BTDL = ($btdl * $quantity), ";
                                else
                                    $q .= "BTDL = NULL, ";
                                if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                    $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                    $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                else
                                    $q .= "BWQUOTA = NULL, ";
                                if ($bwcount != "")
                                    $q .= "BWCOUNT = $bwcount, ";
                                else
                                    $q .= "BWCOUNT = NULL, ";
                                if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                    $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                    $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                else
                                    $q .= "BWQUOTAUL = NULL, ";
                                if ($bwcountul != "")
                                    $q .= "BWCOUNTUL = $bwcountul, ";
                                else
                                    $q .= "BWCOUNTUL = NULL, ";
                                if ($sdate != "")
                                    $q .= "SDATE = '$sdate', ";
                                else
                                    $q .= "SDATE = NULL, ";
                                if ($edate != "")
                                    $q .= "EDATE = '$edate', ";
                                else
                                    $q .= "EDATE = NULL, ";
                                if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                    $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                    $q .= "LOGINS = ($logins * $quantity), ";
                                if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                    $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                    $q .= "EMINUTES = ($minutes * $quantity), ";
                                if ($startmod != "")
                                    $q .= "STARTMOD = $startmod, ";
                                if ($plan_status != "")
                                    $q .= "STATUS = $plan_status, ";
                                if ($bwrmethod != "")
                                    $q .= "BWRMETHOD = '$bwrmethod', ";
                                if ($bwrperiod != "")
                                    $q .= "BWRPERIOD = $bwrperiod, ";
                                else
                                    $q .= "BWRPERIOD = NULL, ";
                                if ($bwrdate != "")
                                    $q .= "BWRDATE = $bwrdate ";
                                else
                                    $q .= "BWRDATE = NULL ";

                                $q .= "WHERE NAME = '$U_NAME';";
                                $result_update=db_query($q);

                                if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                {
                                    $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                    $result_update=db_query($q);
                                }

                                $log_msg_strings.="Status changed to Completed. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                echo "Updated";                 
                            }
                        }
                        if (strcmp ($payment_status, "Pending") == 0)
                        {
                            $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                            $result3=db_query($q3);
                            $max_no=1;
                            while(odbc_fetch_row($result3))
                            {
                                $max_no=round(odbc_result($result3,1));
                            }
                            if ($max_no >= $invoice_start) $max=round($max_no)+1;
                            else $max=$invoice_start;

                            if (strcmp ($pending_release, "yes") == 0)
                            {
                                $q="SELECT * from ".$ppal_table." where invoice =$new_invoice and pay_status = 'PendingY' and USERNAME = '$username' and SUBSCR_ID = '$subscr_id';";
                                $result_update=db_query($q);
                                if (odbc_fetch_row($result_update) == FALSE)
                                {
                                    $payment_status = "PendingY";
                                    $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'PendingY', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                                    $result_insert=db_query($q_insert);

                                    $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                    $result_plan = db_query($q_plan);

                                    $count_plan = 0;
                                    while(odbc_fetch_row($result_plan))
                                    {
                                        $count_plan = $count_plan + 1;
                                    }

                                    if ($count_plan == 0)
                                    {
                                        $log_msg_strings.="Availiable plan does not exists.";
                                        echo "Availiable plan does not exists";
                                    }
                                    else
                                    {
                                        $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                        $btul = odbc_result($result_plan, 'BTUL');
                                        $btdl = odbc_result($result_plan, 'BTDL');
                                        $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                        $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                        $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                        $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                        $sdate = odbc_result($result_plan, 'SDATE');
                                        $edate = odbc_result($result_plan, 'EDATE');
                                        $logins = odbc_result($result_plan, 'LOGINS');
                                        $minutes = odbc_result($result_plan, 'EMINUTES');
                                        $startmod = odbc_result($result_plan, 'STARTMOD');
                                        $plan_status = odbc_result($result_plan, 'STATUS');
                                        $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                        $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                        $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                        $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                        $result_usr = db_query($q_usr);

                                        $q = "UPDATE ".$fsusr_table." SET ";

                                        if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                            $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                        else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                            $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                        else
                                            $q .= "TIMELEFT = NULL, ";
                                        if ($btul != "")
                                            $q .= "BTUL = ($btul * $quantity), ";
                                        else
                                            $q .= "BTUL = NULL, ";
                                        if ($btdl != "")
                                            $q .= "BTDL = ($btdl * $quantity), ";
                                        else
                                            $q .= "BTDL = NULL, ";
                                        if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                            $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                        else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                            $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                        else
                                            $q .= "BWQUOTA = NULL, ";
                                        if ($bwcount != "")
                                            $q .= "BWCOUNT = $bwcount, ";
                                        else
                                            $q .= "BWCOUNT = NULL, ";
                                        if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                            $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                        else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                            $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                        else
                                            $q .= "BWQUOTAUL = NULL, ";
                                        if ($bwcountul != "")
                                            $q .= "BWCOUNTUL = $bwcountul, ";
                                        else
                                            $q .= "BWCOUNTUL = NULL, ";
                                        if ($sdate != "")
                                            $q .= "SDATE = '$sdate', ";
                                        else
                                            $q .= "SDATE = NULL, ";
                                        if ($edate != "")
                                            $q .= "EDATE = '$edate', ";
                                        else
                                            $q .= "EDATE = NULL, ";
                                        if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                            $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                        else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                            $q .= "LOGINS = ($logins * $quantity), ";
                                        if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                            $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                        else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                            $q .= "EMINUTES = ($minutes * $quantity), ";
                                        if ($startmod != "")
                                            $q .= "STARTMOD = $startmod, ";
                                        if ($plan_status != "")
                                            $q .= "STATUS = $plan_status, ";
                                        if ($bwrmethod != "")
                                            $q .= "BWRMETHOD = '$bwrmethod', ";
                                        if ($bwrperiod != "")
                                            $q .= "BWRPERIOD = $bwrperiod, ";
                                        else
                                            $q .= "BWRPERIOD = NULL, ";
                                        if ($bwrdate != "")
                                            $q .= "BWRDATE = $bwrdate ";
                                        else
                                            $q .= "BWRDATE = NULL ";

                                        $q .= "WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);

                                        if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                        {
                                            $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                            $result_update=db_query($q);
                                        }

                                        $log_msg_strings.="Status added to PendingY. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                        echo "Pending with release updated";
                                    }
                                }
                                else
                                {
                                    $log_msg_strings.= "Duplicated PendingY requests. No extra credit issued.";
                                    echo "PendingY updated before already.";
                                }
                            }

                            if (strcmp ($pending_release, "no") == 0)
                            {
                                $q="SELECT * from ".$ppal_table." where invoice =$new_invoice and pay_status = 'PendingY' and USERNAME = '$username';";
                                $result_update=db_query($q);
                                if (odbc_fetch_row($result_update) == FALSE)
                                {
                                    $payment_status = "PendingN";
                                    $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'PendingN', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                                    $result_insert=db_query($q_insert);
                                    $log_msg_strings.="Status changed to PendingN. No credit issued yet.";
                                    echo "Pending with NOT release updated";
                                }
                                else
                                {
                                    $log_msg_strings.="Ignore request to change status from PendingY to PendingN. No credit issued.";
                                    echo "PendingY updated before already.";
                                }
                            }
                        }
                        if (strcmp ($payment_status, "Refunded") == 0)
                        {
                            $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                            $result3=db_query($q3);
                            $max_no=1;
                            while(odbc_fetch_row($result3))
                            {
                                $max_no=round(odbc_result($result3,1));
                            }
                            if ($max_no >= $invoice_start) $max=round($max_no)+1;
                            else $max=$invoice_start;

                            $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Refunded', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                            $result_insert=db_query($q_insert);

                            $log_msg_strings.="A refund has been confirmed. Status changed to Refunded. No credit deducted.";
                        }
                    }
                    if (isset($not_update) && ($not_update == true))
                    {
                        $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                        $result3=db_query($q3);
                        $max_no=1;
                        while(odbc_fetch_row($result3))
                        {
                            $max_no=round(odbc_result($result3,1));
                        }
                        if ($max_no >= $invoice_start) $max=round($max_no)+1;
                        else $max=$invoice_start;

                        if (strcmp ($pending_release, "yes") == 0)
                        {
                            $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'PendingY', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                            $result_insert=db_query($q_insert);

                            $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                            $result_plan = db_query($q_plan);

                            $count_plan = 0;
                            while(odbc_fetch_row($result_plan))
                            {
                                $count_plan = $count_plan + 1;
                            }

                            if ($count_plan == 0)
                            {
                                $log_msg_strings.="Availiable plan does not exists.";
                                echo "Availiable plan does not exists";
                            }
                            else
                            {
                                $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                $btul = odbc_result($result_plan, 'BTUL');
                                $btdl = odbc_result($result_plan, 'BTDL');
                                $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                $sdate = odbc_result($result_plan, 'SDATE');
                                $edate = odbc_result($result_plan, 'EDATE');
                                $logins = odbc_result($result_plan, 'LOGINS');
                                $minutes = odbc_result($result_plan, 'EMINUTES');
                                $startmod = odbc_result($result_plan, 'STARTMOD');
                                $plan_status = odbc_result($result_plan, 'STATUS');
                                $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                $result_usr = db_query($q_usr);

                                $q = "UPDATE ".$fsusr_table." SET ";

                                if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                    $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                    $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                else
                                    $q .= "TIMELEFT = NULL, ";
                                if ($btul != "")
                                    $q .= "BTUL = ($btul * $quantity), ";
                                else
                                    $q .= "BTUL = NULL, ";
                                if ($btdl != "")
                                    $q .= "BTDL = ($btdl * $quantity), ";
                                else
                                    $q .= "BTDL = NULL, ";
                                if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                    $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                    $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                else
                                    $q .= "BWQUOTA = NULL, ";
                                if ($bwcount != "")
                                    $q .= "BWCOUNT = $bwcount, ";
                                else
                                    $q .= "BWCOUNT = NULL, ";
                                if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                    $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                    $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                else
                                    $q .= "BWQUOTAUL = NULL, ";
                                if ($bwcountul != "")
                                    $q .= "BWCOUNTUL = $bwcountul, ";
                                else
                                    $q .= "BWCOUNTUL = NULL, ";
                                if ($sdate != "")
                                    $q .= "SDATE = '$sdate', ";
                                else
                                    $q .= "SDATE = NULL, ";
                                if ($edate != "")
                                    $q .= "EDATE = '$edate', ";
                                else
                                    $q .= "EDATE = NULL, ";
                                if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                    $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                    $q .= "LOGINS = ($logins * $quantity), ";
                                if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                    $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                    $q .= "EMINUTES = ($minutes * $quantity), ";
                                if ($startmod != "")
                                    $q .= "STARTMOD = $startmod, ";
                                if ($plan_status != "")
                                    $q .= "STATUS = $plan_status, ";
                                if ($bwrmethod != "")
                                    $q .= "BWRMETHOD = '$bwrmethod', ";
                                if ($bwrperiod != "")
                                    $q .= "BWRPERIOD = $bwrperiod, ";
                                else
                                    $q .= "BWRPERIOD = NULL, ";
                                if ($bwrdate != "")
                                    $q .= "BWRDATE = $bwrdate ";
                                else
                                    $q .= "BWRDATE = NULL ";

                                $q .= "WHERE NAME = '$U_NAME';";
                                $result_update=db_query($q);

                                if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                {
                                    $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                    $result_update=db_query($q);
                                }

                                $log_msg_strings.="Status changed to PendingY. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                echo "Pending with release updated";
                            }
                        }
                        else if (strcmp ($pending_release, "no") == 0)
                        {
                            $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'PendingN', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                            $result_insert=db_query($q_insert);

                            $log_msg_strings.="Status changed to PendingN. No credit issued yet.";
                            echo "Pending with NOT release updated";
                        }
                    }
                }
                else
                {
                    $log_msg_strings.="mc_gross does not equal amount x quantity. No credit issued.";
                    echo "error:  mc_gross != amount x quantity";
                }
            }
            if ($count != 1)
            {
                $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
                echo "error: no record for this invoice, item_name, custom = plan" ;
            }
        }
        else
        {
            $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
            echo "error: receiver_email != ppal_business";
        }
    }
    else if ($txn_type=="subscr_eot")
    {
        if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
        {
            //check invoice, item_name, custom = plan
            $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username' and SUBSCR_ID = '$subscr_id';";
            $result=db_query($q);
            $count = 0;
            $count2 = 0;    
            while(odbc_fetch_row($result))
            {
                $count = $count + 1;

                $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                $result3=db_query($q3);
                $max_no=1;
                while(odbc_fetch_row($result3))
                {
                    $max_no=round(odbc_result($result3,1));
                }
                if ($max_no >= $invoice_start) $max=round($max_no)+1;
                else $max=$invoice_start;

                $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'End Of Term', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                $result_insert=db_query($q_insert);

                $log_msg_strings.="A End of Term signal recieved. No extra credit will be issued.";
                echo "subscr_eot";
            }
            if ($count != 1)
            {
                $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
                echo "error: no record for this invoice, item_name, custom = plan" ;
            }
        }
        else
        {
            $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
            echo "error: receiver_email != ppal_business";
        }
    }
    else if ($txn_type=="subscr_modify")
    {
        if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
        {
            //check invoice, item_name, custom = plan
            $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username' and SUBSCR_ID = '$subscr_id';";
            $result=db_query($q);
            $count = 0;
            $count2 = 0;    
            while(odbc_fetch_row($result))
            {
                $count = $count + 1;

                $q3="SELECT max(INVOICE) FROM ".$ppal_table.";";
                $result3=db_query($q3);
                $max_no=1;
                while(odbc_fetch_row($result3))
                {
                    $max_no=round(odbc_result($result3,1));
                }
                if ($max_no >= $invoice_start) $max=round($max_no)+1;
                else $max=$invoice_start;

                $q_insert="INSERT INTO ".$ppal_table." (USERNAME, ITEM_NAME, INVOICE, AMOUNT, PLANNAME, QUANTITY, ORDER_DATE, CURR, PAY_STATUS, PENDREASON, PAY_DATE, TXN_ID, PAY_TYPE, FIRST_NAME, LAST_NAME, PAYEREMAIL, PAYER_ID, TXN_TYPE, SUBSCRDATE, SUBSCR_ID, METHOD) VALUES ('".odbc_result($result, 'USERNAME')."', '".odbc_result($result, 'ITEM_NAME')."', '$max', '".odbc_result($result, 'AMOUNT')."', '".odbc_result($result, 'PLANNAME')."', '".odbc_result($result, 'QUANTITY')."', '".odbc_result($result, 'ORDER_DATE')."', '".odbc_result($result, 'CURR')."', 'Modify', '$pending_reason', '$payment_date', '$txn_id', '$payment_type', '$first_name', '$last_name', '$payer_email', '$payer_id', '$txn_type', '$subscr_date', '$subscr_id', '".odbc_result($result, 'METHOD')."');";
                $result_insert=db_query($q_insert);

                $log_msg_strings.="A Modify signal recieved. No extra credit will be issued.";
                echo "subscr_modify";
            }
            if ($count != 1)
            {
                $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
                echo "error: no record for this invoice, item_name, custom = plan" ;
            }
        }
        else
        {
            $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
            echo "error: receiver_email != ppal_business";
        }
    }

    else if (strcmp (strtolower($receiver_email), strtolower($business)) == 0)
    {
        //check invoice, item_name, custom = plan
        $q="SELECT * FROM ".$ppal_table." where invoice=$invoice and planname = '$plan' and quantity = '$quantity' and CURR = '$payment_currency' and USERNAME = '$username';";
        $result=db_query($q);
        $count = 0;
        $count2 = 0;    
        while(odbc_fetch_row($result))
        {
            $count = 1; 
            //check mc_gross >= amount x quantity
            if ($payment_amount >= odbc_result($result, "AMOUNT") * odbc_result($result, "QUANTITY"))
            {
                //check txn_id has not been processed               
                $q2="SELECT * FROM ".$ppal_table." where TXN_ID='$txn_id';";
                //$q2="SELECT * FROM PPAL";
                $result2=db_query($q2);

                while(odbc_fetch_row($result2))
                {
                    $count2 = $count2 + 1;              
                }

                if ($count2 <= 1)
                {
                    $q2="SELECT * FROM ".$ppal_table." where INVOICE = $invoice AND USERNAME= '$username';";
                    $result2=db_query($q2);

                    $U_NAME = odbc_result($result2, "USERNAME");
                    if (strcmp ($payment_status, "Completed") == 0)
                    {
                        if (strcmp (odbc_result($result2, "PAY_STATUS"), "Completed") == 0)
                        {
                            $log_msg_strings.= "This transaction has been processed and completed previously. No extra credit will be issued.";
                            echo "Previously processed";    
                        }
                        else
                        {
                            if (strcmp (odbc_result($result2, "PAY_STATUS"), "PendingY") == 0)
                            {
                                $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $invoice and username = '$username';";
                                $result_update=db_query($q);
                                $log_msg_strings.= "Status changed from PendingY to Completed. No extra credit will be issued.";
                                echo "Pending Released = Y updated to completed";                   
                            }
                            else if (strcmp (odbc_result($result2, "PAY_STATUS"), "PendingN") == 0)
                            {
                                $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $invoice and username = '$username';";
                                $result_update=db_query($q);

                                $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                $result_plan = db_query($q_plan);

                                $count_plan = 0;
                                while(odbc_fetch_row($result_plan))
                                {
                                    $count_plan = $count_plan + 1;
                                }

                                if ($count_plan == 0)
                                {
                                    $log_msg_strings.="Availiable plan does not exists.";
                                    echo "Availiable plan does not exists";
                                }
                                else
                                {
                                    $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                    $btul = odbc_result($result_plan, 'BTUL');
                                    $btdl = odbc_result($result_plan, 'BTDL');
                                    $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                    $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                    $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                    $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                    $sdate = odbc_result($result_plan, 'SDATE');
                                    $edate = odbc_result($result_plan, 'EDATE');
                                    $logins = odbc_result($result_plan, 'LOGINS');
                                    $minutes = odbc_result($result_plan, 'EMINUTES');
                                    $startmod = odbc_result($result_plan, 'STARTMOD');
                                    $plan_status = odbc_result($result_plan, 'STATUS');
                                    $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                    $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                    $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                    $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                    $result_usr = db_query($q_usr);

                                    $q = "UPDATE ".$fsusr_table." SET ";

                                    if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                        $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                    else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                        $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                    else
                                        $q .= "TIMELEFT = NULL, ";
                                    if ($btul != "")
                                        $q .= "BTUL = ($btul * $quantity), ";
                                    else
                                        $q .= "BTUL = NULL, ";
                                    if ($btdl != "")
                                        $q .= "BTDL = ($btdl * $quantity), ";
                                    else
                                        $q .= "BTDL = NULL, ";
                                    if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                        $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                    else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                        $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                    else
                                        $q .= "BWQUOTA = NULL, ";
                                    if ($bwcount != "")
                                        $q .= "BWCOUNT = $bwcount, ";
                                    else
                                        $q .= "BWCOUNT = NULL, ";
                                    if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                        $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                    else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                        $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                    else
                                        $q .= "BWQUOTAUL = NULL, ";
                                    if ($bwcountul != "")
                                        $q .= "BWCOUNTUL = $bwcountul, ";
                                    else
                                        $q .= "BWCOUNTUL = NULL, ";
                                    if ($sdate != "")
                                        $q .= "SDATE = '$sdate', ";
                                    else
                                        $q .= "SDATE = NULL, ";
                                    if ($edate != "")
                                        $q .= "EDATE = '$edate', ";
                                    else
                                        $q .= "EDATE = NULL, ";
                                    if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                        $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                    else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                        $q .= "LOGINS = ($logins * $quantity), ";
                                    if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                        $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                    else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                        $q .= "EMINUTES = ($minutes * $quantity), ";
                                    if ($startmod != "")
                                        $q .= "STARTMOD = $startmod, ";
                                    if ($plan_status != "")
                                        $q .= "STATUS = $plan_status, ";
                                    if ($bwrmethod != "")
                                        $q .= "BWRMETHOD = '$bwrmethod', ";
                                    if ($bwrperiod != "")
                                        $q .= "BWRPERIOD = $bwrperiod, ";
                                    else
                                        $q .= "BWRPERIOD = NULL, ";
                                    if ($bwrdate != "")
                                        $q .= "BWRDATE = $bwrdate ";
                                    else
                                        $q .= "BWRDATE = NULL ";

                                    $q .= "WHERE NAME = '$U_NAME';";
                                    $result_update=db_query($q);

                                    if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                    {
                                        $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);
                                    }

                                    $log_msg_strings.="Status changed from PendingN to Completed. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                    echo "Pending Released = N updated to completed, plan updated";                                         
                                }
                            }
                            else 
                            {

                                $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $invoice and username = '$username';";
                                $result_update=db_query($q);                                

                                $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                $result_plan = db_query($q_plan);

                                $count_plan = 0;
                                while(odbc_fetch_row($result_plan))
                                {
                                    $count_plan = $count_plan + 1;
                                }

                                if ($count_plan == 0)
                                {
                                    $log_msg_strings.="Availiable plan does not exists.";
                                    echo "Availiable plan does not exists";
                                }
                                else
                                {
                                    $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                    $btul = odbc_result($result_plan, 'BTUL');
                                    $btdl = odbc_result($result_plan, 'BTDL');
                                    $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                    $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                    $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                    $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                    $sdate = odbc_result($result_plan, 'SDATE');
                                    $edate = odbc_result($result_plan, 'EDATE');
                                    $logins = odbc_result($result_plan, 'LOGINS');
                                    $minutes = odbc_result($result_plan, 'EMINUTES');
                                    $startmod = odbc_result($result_plan, 'STARTMOD');
                                    $plan_status = odbc_result($result_plan, 'STATUS');
                                    $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                    $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                    $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                    $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                    $result_usr = db_query($q_usr);

                                    $q = "UPDATE ".$fsusr_table." SET ";

                                    if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                        $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                    else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                        $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                    else
                                        $q .= "TIMELEFT = NULL, ";
                                    if ($btul != "")
                                        $q .= "BTUL = ($btul * $quantity), ";
                                    else
                                        $q .= "BTUL = NULL, ";
                                    if ($btdl != "")
                                        $q .= "BTDL = ($btdl * $quantity), ";
                                    else
                                        $q .= "BTDL = NULL, ";
                                    if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                        $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                    else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                        $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                    else
                                        $q .= "BWQUOTA = NULL, ";
                                    if ($bwcount != "")
                                        $q .= "BWCOUNT = $bwcount, ";
                                    else
                                        $q .= "BWCOUNT = NULL, ";
                                    if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                        $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                    else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                        $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                    else
                                        $q .= "BWQUOTAUL = NULL, ";
                                    if ($bwcountul != "")
                                        $q .= "BWCOUNTUL = $bwcountul, ";
                                    else
                                        $q .= "BWCOUNTUL = NULL, ";
                                    if ($sdate != "")
                                        $q .= "SDATE = '$sdate', ";
                                    else
                                        $q .= "SDATE = NULL, ";
                                    if ($edate != "")
                                        $q .= "EDATE = '$edate', ";
                                    else
                                        $q .= "EDATE = NULL, ";
                                    if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                        $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                    else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                        $q .= "LOGINS = ($logins * $quantity), ";
                                    if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                        $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                    else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                        $q .= "EMINUTES = ($minutes * $quantity), ";
                                    if ($startmod != "")
                                        $q .= "STARTMOD = $startmod, ";
                                    if ($plan_status != "")
                                        $q .= "STATUS = $plan_status, ";
                                    if ($bwrmethod != "")
                                        $q .= "BWRMETHOD = '$bwrmethod', ";
                                    if ($bwrperiod != "")
                                        $q .= "BWRPERIOD = $bwrperiod, ";
                                    else
                                        $q .= "BWRPERIOD = NULL, ";
                                    if ($bwrdate != "")
                                        $q .= "BWRDATE = $bwrdate ";
                                    else
                                        $q .= "BWRDATE = NULL ";

                                    $q .= "WHERE NAME = '$U_NAME';";
                                    $result_update=db_query($q);

                                    if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                    {
                                        $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);
                                    }

                                    $log_msg_strings.="Status changed to Completed. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                    echo "Updated";                 
                                }
                            }
                        }
                    }

                    if (strcmp ($payment_status, "Pending") == 0)
                    {
                        if (strcmp (odbc_result($result2, "PAY_STATUS"), "Completed") == 0)
                        {
                            $log_msg_strings.="Ignore request to change status from Completed to Pending. No credit issued.";
                            echo "Previously processed can't Completed -> Pending"; 
                        }
                        else
                        {
                            if (strcmp ($pending_release, "yes") == 0)
                            {
                                $q="SELECT * from ".$ppal_table." where invoice =$invoice and pay_status = 'PendingY' and USERNAME = '$username';";
                                $result_update=db_query($q);
                                if (odbc_fetch_row($result_update) == FALSE)
                                {
                                    $payment_status = "PendingY";
                                    $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $invoice and username='$username';";
                                    $result_update=db_query($q);

                                    $q_plan = "SELECT * FROM ".$plan_table." WHERE PNAME = '".$plan."' ;";
                                    $result_plan = db_query($q_plan);

                                    $count_plan = 0;
                                    while(odbc_fetch_row($result_plan))
                                    {
                                        $count_plan = $count_plan + 1;
                                    }

                                    if ($count_plan == 0)
                                    {
                                        $log_msg_strings.="Availiable plan does not exists.";
                                        echo "Availiable plan does not exists";
                                    }
                                    else
                                    {
                                        $timeleft = odbc_result($result_plan, 'TIMELEFT');
                                        $btul = odbc_result($result_plan, 'BTUL');
                                        $btdl = odbc_result($result_plan, 'BTDL');
                                        $bwquota = odbc_result($result_plan, 'BWQUOTA');
                                        $bwcount = odbc_result($result_plan, 'BWCOUNT');
                                        $bwquotaul = odbc_result($result_plan, 'BWQUOTAUL');
                                        $bwcountul = odbc_result($result_plan, 'BWCOUNTUL');
                                        $sdate = odbc_result($result_plan, 'SDATE');
                                        $edate = odbc_result($result_plan, 'EDATE');
                                        $logins = odbc_result($result_plan, 'LOGINS');
                                        $minutes = odbc_result($result_plan, 'EMINUTES');
                                        $startmod = odbc_result($result_plan, 'STARTMOD');
                                        $plan_status = odbc_result($result_plan, 'STATUS');
                                        $bwrmethod = odbc_result($result_plan, 'BWRMETHOD');
                                        $bwrperiod = odbc_result($result_plan, 'BWRPERIOD');
                                        $bwrdate = odbc_result($result_plan, 'BWRDATE');

                                        $q_usr = "SELECT * FROM ".$fsusr_table." WHERE NAME = '$U_NAME';";
                                        $result_usr = db_query($q_usr);

                                        $q = "UPDATE ".$fsusr_table." SET ";

                                        if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") != ""))
                                            $q .= "TIMELEFT = TIMELEFT + ($timeleft * $quantity), ";
                                        else if (($timeleft != "") && (odbc_result($result_usr, "TIMELEFT") == ""))
                                            $q .= "TIMELEFT = ($timeleft * $quantity), ";
                                        else
                                            $q .= "TIMELEFT = NULL, ";
                                        if ($btul != "")
                                            $q .= "BTUL = ($btul * $quantity), ";
                                        else
                                            $q .= "BTUL = NULL, ";
                                        if ($btdl != "")
                                            $q .= "BTDL = ($btdl * $quantity), ";
                                        else
                                            $q .= "BTDL = NULL, ";
                                        if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") != ""))
                                            $q .= "BWQUOTA = BWQUOTA + ($bwquota * $quantity), ";
                                        else if (($bwquota != "") && (odbc_result($result_usr, "BWQUOTA") == ""))
                                            $q .= "BWQUOTA = ($bwquota * $quantity), ";
                                        else
                                            $q .= "BWQUOTA = NULL, ";
                                        if ($bwcount != "")
                                            $q .= "BWCOUNT = $bwcount, ";
                                        else
                                            $q .= "BWCOUNT = NULL, ";
                                        if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") != ""))
                                            $q .= "BWQUOTAUL = BWQUOTAUL + ($bwquotaul * $quantity), ";
                                        else if (($bwquotaul != "") && (odbc_result($result_usr, "BWQUOTAUL") == ""))
                                            $q .= "BWQUOTAUL = ($bwquotaul * $quantity), ";
                                        else
                                            $q .= "BWQUOTAUL = NULL, ";
                                        if ($bwcountul != "")
                                            $q .= "BWCOUNTUL = $bwcountul, ";
                                        else
                                            $q .= "BWCOUNTUL = NULL, ";
                                        if ($sdate != "")
                                            $q .= "SDATE = '$sdate', ";
                                        else
                                            $q .= "SDATE = NULL, ";
                                        if ($edate != "")
                                            $q .= "EDATE = '$edate', ";
                                        else
                                            $q .= "EDATE = NULL, ";
                                        if (($logins != "") && (odbc_result($result_usr, "LOGINS") != ""))
                                            $q .= "LOGINS = LOGINS + ($logins * $quantity), ";
                                        else if (($logins != "") && (odbc_result($result_usr, "LOGINS") == ""))
                                            $q .= "LOGINS = ($logins * $quantity), ";
                                        if (($minutes != "") && (odbc_result($result_usr, "EMINUTES") != ""))
                                            $q .= "EMINUTES = EMINUTES + ($minutes * $quantity), ";
                                        else if (($minutes != "") && (odbc_result($result_usr, "EMINUTES")== ""))
                                            $q .= "EMINUTES = ($minutes * $quantity), ";
                                        if ($startmod != "")
                                            $q .= "STARTMOD = $startmod, ";
                                        if ($plan_status != "")
                                            $q .= "STATUS = $plan_status, ";
                                        if ($bwrmethod != "")
                                            $q .= "BWRMETHOD = '$bwrmethod', ";
                                        if ($bwrperiod != "")
                                            $q .= "BWRPERIOD = $bwrperiod, ";
                                        else
                                            $q .= "BWRPERIOD = NULL, ";
                                        if ($bwrdate != "")
                                            $q .= "BWRDATE = $bwrdate ";
                                        else
                                            $q .= "BWRDATE = NULL ";

                                        $q .= "WHERE NAME = '$U_NAME';";
                                        $result_update=db_query($q);

                                        if (($timeleft == "") && ($edate == "") && ($logins == "") && ($minutes == ""))
                                        {
                                            $q = "UPDATE ".$fsusr_table." SET TIMELEFT = NULL, EDATE = NULL, LOGINS = NULL, EMINUTES = NULL WHERE NAME = '$U_NAME';";
                                            $result_update=db_query($q);
                                        }

                                        $log_msg_strings.="Status changed to PendingY. Credits issued: ".$quantity." units of ".$plan." to user ".$U_NAME.".";
                                        echo "Pending with release updated";
                                    }
                                }
                                else
                                {
                                    $log_msg_strings.= "Duplicated PendingY requests. No extra credit issued.";
                                    echo "PendingY updated before already.";
                                }
                            }
                            if (strcmp ($pending_release, "no") == 0)
                            {
                                $q="SELECT * from ".$ppal_table." where invoice =$invoice and pay_status = 'PendingY' and USERNAME = '$username';";
                                $result_update=db_query($q);
                                if (odbc_fetch_row($result_update) == FALSE)
                                {
                                    $payment_status = "PendingN";
                                    $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status'".$sql_paypal." where invoice = $invoice and username='$username';";
                                    $result_update=db_query($q);    
                                    $log_msg_strings.="Status changed to PendingN. No credit issued yet.";
                                    echo "Pending with NOT release updated";
                                }
                                else
                                {
                                    $log_msg_strings.="Ignore request to change status from PendingY to PendingN. No credit issued.";
                                    echo "PendingY updated before already.";
                                }                                                                    
                            }
                        }
                    }

                    if (strcmp ($payment_status, "Refunded") == 0)
                    {
                        $q="Update ".$ppal_table." set PAY_STATUS = '$payment_status' where invoice = $invoice and username = '$username';";
                        $result_update=db_query($q);
                        $log_msg_strings.="A refund has been confirmed. Status changed to Refunded. No credit deducted.";
                    }
                }
                else
                {
                    $log_msg_strings.="More than one records of the same txn_id. No credit issued.";
                    echo "More than 1 record";
                }
            }
            else
            {
                $log_msg_strings.="mc_gross does not equal amount x quantity. No credit issued.";
                echo "error:  mc_gross != amount x quantity";
            }
        }
        if ($count != 1)
        {
            $log_msg_strings.= "No such record exists with matching invoice # OR item name OR quantity OR currency OR custom plan values. No credit issued.";
            echo "error: no record for this invoice, item_name, custom = plan" ;
        }
    }
    else
    {
        $log_msg_strings.="Paypal receiver email (i.e. business id) does not match the setting in Config Mgr. No credit issued.";
        echo "error: receiver_email != ppal_business";
    }       

    // check the payment_status is Completed
    // check that txn_id has not been previously processed
    // check that receiver_email is your Primary PayPal email
    // check that payment_amount/payment_currency are correct
    // process payment

}
else if (strcmp ($res, "INVALID") == 0)
{
    // log for manual investigation
    $log_msg_strings.="Paypal returned invalid verification result. No credit issued.";
    echo "INVALID";
}
else $log_msg_strings.="Paypal returned no verification result. No credit issued.";

if ($lockFileHandler)
{
    flock ($lockFileHandler, LOCK_UN ); // release the lock
    fclose ($lockFileHandler);
    while (!unlink($lock_file))
    {
        $log_msg_strings.=" Fail to delete the lock file. ";
    }
}

//log the posted strings to the txn log file
if ( !isset($U_NAME)) 
    $U_NAME="";
$log_msg_strings =$invoice."\t".$log_msg_strings."\t".$payment_status."\t".$U_NAME."\t".$plan."\t".$quantity."\t".$item_name."\t".$txn_id."\t".$mc_gross."\t".$mc_fee."\t".$tax."\t".$payment_gross."\t".$payment_fee."\t".$payment_type."\t".$payment_date."\t".$txn_type."\t".$first_name."\t".$last_name."\t".$payer_email."\t";
$buff = file_get_contents($paypal_txn_log);
$log_msg_content= $log_msg_time."\t".$log_msg_ip."\t".$log_msg_strings.$log_msg_strings_posted."\n";
$fileHandler = fopen ($paypal_txn_log, "w");
fwrite ($fileHandler, $buff.$log_msg_content);
fclose ($fileHandler);

?>
